/***************************************************************************
                          i8kkmon.cpp  -  description
                             -------------------
    begin                : Don Okt 24 23:38:17 CEST 2002
    copyright            : (C) 2002 by Dieter Landolt
    email                : dieter.landolt@secs.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

static const char* const img0_fan[] = {
"18 18 32 1",
". c None",
"a c #182029",
"# c #202029",
"z c #202429",
"C c #202431",
"B c #292831",
"e c #313039",
"D c #393439",
"b c #393841",
"c c #414041",
"d c #41404a",
"A c #4a444a",
"y c #4a4852",
"m c #524c4a",
"l c #524c52",
"q c #525052",
"s c #5a595a",
"j c #626162",
"w c #626562",
"r c #6a6162",
"k c #6a656a",
"x c #6a696a",
"t c #6a6d6a",
"p c #73696a",
"v c #736d6a",
"h c #736d73",
"g c #737173",
"u c #7b757b",
"i c #7b797b",
"n c #7b7d7b",
"o c #837d83",
"f c #838183",
"....###a###a##....",
"...#a#abcde#a#a...",
"..###a#fghf##a##..",
".#a#a..fhgf..#a#a.",
"###a...fghf...#a##",
"a#a....ijki....#a#",
"#a#...llllll...##a",
"a#...lmlmlmlm...a#",
"##...llllllll...##",
"a#..nlmlmlmlkf..a#",
"#aofpllllllqrgfs#a",
"a#tillmlmlqufvwxa#",
"##ysllllllgfffob##",
"a#admlml....ffx###",
".a#zAll......zB#C.",
"..a#aDz....#a#a#..",
"...a###a###a###...",
"....a#a#a#a#a#...."};

static const char* const img2_fan[] = {
"18 18 47 1",
". c None",
"a c #182029",
"# c #202029",
"b c #202429",
"g c #202431",
"F c #202829",
"K c #202831",
"o c #292831",
"R c #292c39",
"G c #313439",
"I c #393441",
"f c #393841",
"c c #393c41",
"S c #413c41",
"d c #414041",
"e c #41404a",
"y c #41444a",
"Q c #4a444a",
"P c #4a4852",
"h c #4a4c52",
"D c #524c4a",
"A c #524c52",
"L c #525052",
"n c #52505a",
"E c #5a5052",
"B c #5a505a",
"J c #5a555a",
"O c #5a595a",
"M c #625d62",
"H c #626162",
"v c #626562",
"t c #62656a",
"l c #6a6562",
"q c #6a656a",
"k c #6a696a",
"z c #6a6973",
"s c #6a6d6a",
"N c #736d6a",
"w c #736d73",
"p c #737173",
"r c #737573",
"j c #7b757b",
"m c #7b797b",
"C c #7b7d7b",
"i c #7b7d83",
"x c #837d83",
"u c #838183",
"....###a###a##....",
"...#a#bcdefba#a...",
"..##ghijklmmnb##..",
".#aokpqrkkpkskb#a.",
"##btkrurqlmujkk###",
"a#esrusjvqrwxmkya#",
"#azkupwAAABppuwk#a",
"aosmCsAADADEsujpF#",
"#GsxmHAAAAAAwmukI#",
"aGkujJDADADAkmCkG#",
"#KpmwAAAAAALMpmwoa",
"a#kkAADADALppNOka#",
"##PJAAALwwmwumkf##",
"a#aeDADwsprurkt#b#",
".a#bQAMpmmjkpko#R.",
"..a#aSmjpprmhba#..",
"...a##gfPycb###...",
"....a#a#a#a#a#...."};

static const char* const img1_fan[] = {
"18 18 119 2",
"Qt c None",
"#K c #182029",
".# c #202029",
"#w c #52505a",
"#p c #7b7983",
"#n c #838183",
".w c #202029",
".M c #838183",
"#X c #202029",
"#k c #7b797b",
".9 c #7b7d7b",
"#d c #838183",
".r c #182029",
".g c #202029",
"#U c #292431",
"#g c #838183",
".F c #182029",
".G c #202029",
"#S c #202429",
"#N c #838183",
"#V c #182029",
".s c #202029",
".R c #182029",
".a c #202029",
"#v c #838183",
".V c #838183",
"#q c #838183",
"#R c #524c52",
".v c #182029",
".B c #202029",
".A c #838183",
".Z c #7b797b",
".L c #838183",
".O c #838183",
"#m c #6a656a",
"#. c #838183",
".f c #182029",
".b c #202029",
"#G c #838183",
".x c #838183",
"#F c #837d83",
".W c #7b797b",
"#l c #524c52",
"#o c #182029",
"#f c #202029",
".h c #182029",
".q c #202029",
"#i c #737173",
".I c #202029",
".Q c #202431",
"#Q c #202029",
"#B c #6a696a",
"#h c #6a656a",
"#M c #7b7573",
"#O c #838183",
".7 c #182029",
".e c #202029",
".c c #182029",
"#x c #6a6d6a",
"#u c #737173",
"#W c #393439",
".n c #313039",
"#e c #182029",
".8 c #202029",
".U c #838183",
"#Y c #313439",
"#0 c #393841",
".H c #182029",
".E c #202029",
"#r c #73696a",
".k c #393841",
".D c #182029",
".t c #202029",
".6 c #736d73",
".1 c #737173",
".j c #182029",
".o c #202029",
".C c #182029",
".u c #202029",
"#T c #292831",
".K c #6a696a",
".P c #6a6973",
"#L c #524c4a",
"#j c #182029",
".d c #202029",
".4 c #5a505a",
"## c #838183",
".2 c #524c52",
"#H c #838183",
".p c #182029",
".i c #202029",
".J c #202429",
"#J c #393841",
".l c #414041",
".m c #41404a",
".S c #41444a",
".0 c #4a444a",
"#C c #4a4852",
"#Z c #4a4c52",
"#b c #524c4a",
".3 c #524c52",
"#s c #525052",
"#c c #5a5052",
"#E c #5a5552",
"#D c #5a595a",
".X c #626562",
"#t c #6a6162",
".Y c #6a656a",
"#P c #6a696a",
"#A c #736d6a",
".z c #736d73",
".y c #737173",
".5 c #737573",
".N c #7b7173",
"#z c #7b757b",
"#y c #7b797b",
"#a c #7b7d7b",
"#I c #837d83",
".T c #838183",
"QtQtQtQt.#.a.b.c.d.d.e.f.a.#QtQtQt.#",
"QtQtQt.g.h.i.j.k.l.m.n.o.p.q.rQtQtQt",
"QtQt.s.t.u.v.w.x.y.z.A.w.B.C.t.sQtQt",
"Qt.g.D.E.FQtQt.x.z.y.AQtQt.G.H.t.rQt",
".#.I.J.K.L.MQt.x.N.z.AQt.M.O.P.i.Q.#",
".R.i.S.T.T.U.V.W.X.Y.Z.V.U.T.T.0.p.a",
".b.p.1.T.T.T.y.2.3.3.4.5.T.T.T.6.i.f",
".7.8.9#.###a.3.3#b.3#b#c#a###.#d#e.e",
".d#fQtQt#g#h.3.3.3.3.3.3#i#gQtQt#f.d",
"#j#fQtQt#k#l#b.3#b.3#b.3#m#nQtQt#o.d",
".e#e#p#q#r.3.3.3.3.3.3#s#t#u#v#w.8.7",
".f.i#x#y.3.3#b.3#b.3#s#z.T#A.X#B.p.b",
".a.i#C#D.3.3.3#E.y.y#F#G#H.T#I#J.i.a",
"#K.q.p.m#b.3#L#M.T.T#.Qt#N#O#P.i#Q.#",
"Qt.r.t.J.0.3#R#..T.T#.QtQt#S#T.t#UQt",
"QtQt#V.t.p#W#X#..T.T#..w.v.u.D.sQtQt",
"QtQtQt.r.q.i.o#Y#Z#C#0.j.i.q.gQtQtQt",
"QtQtQtQt#K.a.f.e#j.d.c.b.R.#QtQtQtQt"};


#include <kdebug.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qfile.h>
#include <qtimer.h>
#include <qtooltip.h>
#include <kglobal.h>
#include <klocale.h>
#include <kconfig.h>
#include <kapp.h>
#include <kmessagebox.h>

#include "i8kkmon.h"

extern "C"
{
  KPanelApplet* init( QWidget *parent, const QString configFile)
  {
    KGlobal::locale()->insertCatalogue("i8kkmon");
    return new I8kkmon(configFile, KPanelApplet::Normal,
    //                  KPanelApplet::About | KPanelApplet::Help | KPanelApplet::Preferences,
                      KPanelApplet::About | KPanelApplet::Help, // | KPanelApplet::Preferences,
                      parent, "i8kkmon");
  }
}

I8kkmon::I8kkmon(const QString& configFile, Type type, int actions, QWidget *parent, const char *name) 
       : KPanelApplet(configFile, type, actions, parent, name)
{
   // Get the current application configuration handle
   ksConfig = config();
   mainView = new myview(this);
   setInfo();
   QTimer *timer = new QTimer( this );
   connect( timer, SIGNAL(timeout()), this, SLOT(updateInfo()) );
   timer->start( 500, false ); // .5 seconds timer
   mainView->setMouseTracking(true);
   mainView->DellLogo->setMouseTracking(true);
   mainView->TempText->setMouseTracking(true);
   mainView->show();
}

I8kkmon::~I8kkmon()
{
}

void I8kkmon::about()
{
   KMessageBox::information(0,
   tr2i18n("This kde applet gives you the ability to watch the temperarury on your dell inspiron laptop\nAutor : Dieter Landolt EMail : dieter.landolt@secs.ch"));
}

                                                                         
void I8kkmon::help()
{
   KMessageBox::information(0,
   tr2i18n("If it is not runing, the i8k utils install will be missed !\nBevore you can use it you have to install and load the i8module i8k.o.\nYou can find it on : http://www.debian.org/~dz/i8k/\nfor SuSE 8.1 Users :\nyou have to remove the i8k module in the /lib/modules/2.4.19-4GB/kernel/drivers/char/i8k.o\nAfter that install the new module" ));
}


void I8kkmon::preferences()
{
   KMessageBox::information(0, tr2i18n("Sorry not implemented at the moment"));  
}

int I8kkmon::widthForHeight( int height ) const
{
   int newwidth;
   if(height < 50) {
      mainView->DellLogo->hide();
   } else {
      mainView->DellLogo->show();
   }     

   if(height < 40) {
      mainView->FanFrame->hide();
   } else {
      mainView->FanFrame->show();
   }

   mainView->setFixedHeight( height );
   if( orientation() == Horizontal) {
     if(height < 40) {
      newwidth =  25;
     } else {      
      newwidth = 48;
     }
   } else {
      newwidth = width();
   }
   mainView->setFixedHeight( height );
   mainView->setFixedWidth( newwidth );
   return newwidth;
}                                                         

int I8kkmon::heightForWidth( int width ) const
{
   int newheiht;
   if( width < 35 ) {
        mainView->FanFrame->hide();
        mainView->DellLogo->hide();
   } else {
        mainView->FanFrame->show();
        mainView->DellLogo->show();
   }     
   if( orientation() == Horizontal) {
     newheiht = 35;
   } else {
     if ( width < 35) {
        newheiht = 22;
     } else {
        newheiht = 62;
     }
   }
   mainView->setFixedWidth(width);
   mainView->setFixedHeight(newheiht);
   return newheiht;
}

void I8kkmon::resizeEvent( QResizeEvent *_Event)
{
   _Event = _Event;
}
/** No descriptions */
void I8kkmon::setInfo(){
  // Opens /dev/i8k if it exist and sets info to button
  static i8kinfo binfo;
  QFile file("/proc/i8k");
  if (file.open( IO_ReadOnly )) {
    QTextStream stream(&file);
    // QString line;
    info = stream.readLine(); // line of text excluding '\n'
    file.close();

    if ( info.cputemp.toInt() != binfo.cputemp.toInt() )
      mainView->TempText->setText(info.cputemp);
    QString mytooltip;
    QString myp;
    if(info.acstate == "1") {
       myp = tr2i18n("on cable");
    } else if (info.acstate == "0") {
       myp = tr2i18n("on battery");
    } else {
       myp = tr2i18n("not accessible");
    }
    
    mytooltip = "BIOS " + info.biosversion + "\n" +
                 tr2i18n("Serialnumber") + " " + info.serialnumber + "\n" +
                 tr2i18n("Powerplug") + " " + myp;
    QToolTip::add(mainView->TempText,mytooltip);
    QToolTip::add(mainView->DellLogo,mytooltip);
    QToolTip::add(mainView,mytooltip);
    } else {
      mainView->TempText->setText("???");
      QToolTip::add(mainView->TempText,tr2i18n("No possibility to show the temperaury\nmaybe i8k module is not loaded"));
    }

    if ( info.leftfanrpm.toInt() != binfo.leftfanrpm.toInt() ) {
      QToolTip::add(mainView->fanLeft,info.leftfanrpm + " rpm");
    }
    if ( info.leftfan.toInt() != binfo.leftfan.toInt() ) {
      switch(info.leftfan.toInt()) {
        case 2: mainView->fanLeft->setPixmap((QPixmap) ( ( const char** ) img2_fan ));
                break;
        case 1: mainView->fanLeft->setPixmap((QPixmap) ( ( const char** ) img1_fan ));
                break;
        case 0: mainView->fanLeft->setPixmap((QPixmap) ( ( const char** ) img0_fan ));
                break;
      }
    }
    if ( info.rightfanrpm.toInt() != binfo.rightfanrpm.toInt() ) {
      QToolTip::add(mainView->fanRight,info.rightfanrpm + " rpm");
    }
    if ( info.rightfan.toInt() != binfo.rightfan.toInt() ) {
      switch(info.rightfan.toInt()) {
        case 2: mainView->fanRight->setPixmap((QPixmap) ( ( const char** ) img2_fan ));
                break;
        case 1: mainView->fanRight->setPixmap((QPixmap) ( ( const char** ) img1_fan ));
                break;
        case 0: mainView->fanRight->setPixmap((QPixmap) ( ( const char** ) img0_fan ));
                break;
      }
    }
    binfo = info;
}
/** wille be called when timer is done or in other situations */
void I8kkmon::updateInfo(){
    setInfo();
}
