/***************************************************************************
                          i8kinfo.cpp  -  description
                             -------------------
    begin                : Mon Nov 11 2002
    copyright            : (C) 2002 by Dieter Landolt
    email                : dieter.landolt@secs.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "i8kinfo.h"
#include <qstringlist.h>

i8kinfo::i8kinfo(){
}
i8kinfo::~i8kinfo(){
}
/** No descriptions */
i8kinfo& i8kinfo::operator=(i8kinfo& s){
  formatversion = s.formatversion;
  biosversion = s.biosversion;
  serialnumber = s.serialnumber;
  cputemp = s.cputemp;
  leftfan = s.leftfan;
  rightfan = s.rightfan;
  leftfanrpm = s.leftfanrpm;
  rightfanrpm = s.rightfanrpm;  
  acstate = s.acstate;
  buttonstate = s.buttonstate;
  return *this;
}
/** Splitup string 1.0 A21 26Q430J 66 0 0 0 0 -1 0
*/                   
i8kinfo& i8kinfo::operator=(QString s){
  QStringList info = QStringList::split(" ",s);
  QStringList::Iterator it = info.begin();
  formatversion = *it;
  biosversion   = *++it;
  serialnumber  = *++it;
  cputemp       = *++it;
  leftfan       = *++it;
  rightfan      = *++it;
  leftfanrpm    = *++it;
  rightfanrpm   = *++it;
  acstate       = *++it;
  buttonstate   = *++it;
  return *this;
}
