/***************************************************************************
                          i8kinfo.h  -  description
                             -------------------
    begin                : Mon Nov 11 2002
    copyright            : (C) 2002 by Dieter Landolt
    email                : dieter.landolt@secs.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef I8KINFO_H
#define I8KINFO_H
#include <qstring.h>

/**
  *@author Dieter Landolt
  */

class i8kinfo {
public: 
	i8kinfo();
	~i8kinfo();
  /** Copy the i8kinfos */
  i8kinfo& operator=(i8kinfo& s);
  /** set i8kinfos via proc String */
  i8kinfo& operator=(QString s);
public: // Public attributes
  /** for holding i8k infos about format of i8k, nessesary to now its allready the right version */
  QString formatversion;
  /** hold the bios version of the dell inspiron */
  QString biosversion;
  /** the laptop serial number */
  QString serialnumber;
  /** temperatury for the cpu */
  QString cputemp;
  /** state of the left fan */
  QString leftfan;
  /** state of the right fan */
  QString rightfan;
  /** rpm of the left fan */
  QString leftfanrpm;
  /** rpm of the right fan */
  QString rightfanrpm;
  /** power ac state */
  QString acstate;
  /** button state */
  QString buttonstate;
};

#endif
